package vishnu.testvis.object;
import java.io.*;
import java.util.*;
import vishnu.datablock.*;


public class CacheManager
{
    
    int cacheSize;
    Vector file_names_dat;
    Vector file_names_doc;
        
    public CacheManager()
    {
        //getCache();
    }
    
    private void getCache()
    {
        Properties p = System.getProperties();
        String currentDir = p.getProperty("user.dir");
        File cache_dir = new File(currentDir);
        file_names_dat = new Vector();
        file_names_doc = new Vector();
        
        String fileArr[] = null;
        if( cache_dir.exists() )
        {
        
            fileArr = cache_dir.list(new FilenameFilter()
            {
                public boolean accept(File dir, String name)
		        {
		            return ( name.endsWith(".dat") || name.endsWith(".doc") );
		        }
	        });
	    }
	    else 
	    {
	        System.out.println("Directory does not exist");
	        System.exit(0);
	    }
	    
	    for( int i = 0; i < fileArr.length; i++ )
	    {   
	        if( fileArr[i].endsWith(".dat") )
	            file_names_dat.addElement(fileArr[i]);
	        if( fileArr[i].endsWith(".doc") )
	            file_names_doc.addElement(fileArr[i]);
	    }	    
    }
           
    public void addDataItem(DataBlock data, String key)
    {   
        String fileName = new String(key +".dat");
        file_names_dat.addElement(fileName);
        
        try
        {
            FileOutputStream ostream = new FileOutputStream(fileName);
            ObjectOutputStream out = new ObjectOutputStream(ostream); 
            out.writeObject(data);
            ostream.close();                
        }
        catch (FileNotFoundException ex) {System.out.println("File not found exception");}
	    catch (IOException ex) {System.out.println("Error when writing to raw_imagebase");}
	    catch (Exception ex) {System.out.println(ex);}
	    
    }
    
     public void addDocItem(Vector doc, String key)
    {   
        String fileName = new String(key +".doc");
        file_names_doc.addElement(fileName);
        
        try
        {
            FileOutputStream ostream = new FileOutputStream(fileName);
            ObjectOutputStream out = new ObjectOutputStream(ostream); 
            out.writeObject(doc);
            ostream.close();                
        }
        catch (FileNotFoundException ex) {System.out.println("File not found exception");}
	    catch (IOException ex) {System.out.println("Error when writing to raw_imagebase");}
	    catch (Exception ex) {System.out.println(ex);}
	    
    }
   
        
    public boolean containsData(String query)
    {
        String path = new String(query+".dat");
        
        if( file_names_dat.contains(path) )
            return true;
            else
            return false;
    }
    
    public boolean containsDoc(String docName)
    {
        String path = new String(docName+".doc");
        
        if( file_names_doc.contains(path) )
            return true;
            else
            return false;
    }
  
    
    public Vector getDoc(String docName)
    {
        String filename = new String(docName + ".doc");
        Vector doc = null;
        
        try
        {
            FileInputStream istream = new FileInputStream(filename);
            ObjectInputStream in = new ObjectInputStream(istream);
            doc = (Vector)in.readObject();        
        }
    	catch (FileNotFoundException ex) {System.out.println("File not found exception");}
	    catch (IOException ex) {System.out.println("Error when writing to raw_imagebase");}
	    catch (Exception ex) {System.out.println(ex);}
	    
        return doc;   
    }
    
    
 
    public DataBlock getData(String query)
    {
        String filename = new String(query + ".dat");
        DataBlock data = null;
        
        try
        {
            FileInputStream istream = new FileInputStream(filename);
            ObjectInputStream in = new ObjectInputStream(istream);
            data = (DataBlock)in.readObject();        
        }
    	catch (FileNotFoundException ex) {System.out.println("File not found exception");}
	    catch (IOException ex) {System.out.println("Error when writing to raw_imagebase");}
	    catch (Exception ex) {System.out.println(ex);}
	    
        return data;   
    }
    
    public int getSize()
    {
        return file_names_dat.size();
    }
    
    public Vector listCache()
    {
        return file_names_dat;
    }
    
    public void printMe()
    {
        for( int i = 0; i < file_names_dat.size(); i++ )
        {
            String object = (String)file_names_dat.elementAt(i);
            System.out.println(object);
        }
    }
  
}
